"use strict";

var LoaderHandler = {


    ShowIAP: function()
    {
        var request = {name:"ShowIAP"};
        extension.postMessage(JSON.stringify(request));
    },
    setReadyState: function()
    {
        var request = {name:"setReadyState"};
        extension.postMessage(JSON.stringify(request));
    },

    requestPurchase: function( value )
    {
        var request = {name:"requestPurchase",data:value};
        return extension.internal.sendSyncMessage(JSON.stringify(request));
    },

    setInitState: function()
    {
        var request = {name:"setInitState"};
        return extension.internal.sendSyncMessage(JSON.stringify(request));
    },


    submitStat: function( event, param, value)
    {
        var jsonData = JSON.stringify({"event":event,"param":param,"value":value})
        var request = {name:"submitStat",data:jsonData};
        extension.postMessage(JSON.stringify(request));
    },

    showTermsOfService: function()
    {
        var request = {name:"showTermsOfService"};
        return extension.internal.sendSyncMessage(JSON.stringify(request));
    },

    showPrivacyPolicy: function()
    {
        var request = {name:"showPrivacyPolicy"};
        return extension.internal.sendSyncMessage(JSON.stringify(request));
    },

    showImpressum: function()
    {
        var request = {name:"showImpressum"};
        return extension.internal.sendSyncMessage(JSON.stringify(request));
    },

    showEndUserLicenseAgreement: function()
    {
        var request = {name:"showEndUserLicenseAgreement"};
        return extension.internal.sendSyncMessage(JSON.stringify(request));
    },

    showUrl: function( value )
    {
        var request = {name:"showUrl",data:value};
        return extension.internal.sendSyncMessage(JSON.stringify(request));
    },
    playSound: function( name, id, volume, loop )
    {
        var jsonData = JSON.stringify({"name":name,"id":id,"volume":volume,"loop":loop});
        var request = {name:"playSound",data:jsonData};
        extension.postMessage(JSON.stringify(request));
    },
    stopSound: function( id )
    {
        var jsonData = JSON.stringify({"id":id});
        var request = {name:"stopSound",data:jsonData};
        extension.postMessage(JSON.stringify(request));
    },
    updateSound: function( id, volume, loop )
    {
        var jsonData = JSON.stringify({"id":id,"volume":volume,"loop":loop});
        var request = {name:"updateSound",data:jsonData};
        extension.postMessage(JSON.stringify(request));
    },
    mute: function()
    {
        var request = {name:"mute"};
        extension.postMessage(JSON.stringify(request));
    },
    unmute: function()
    {
        var request = {name:"unmute"};
        extension.postMessage(JSON.stringify(request));
    },
    introHasFinished: function()
    {
        var request = {name:"introHasFinished"};
        extension.postMessage(JSON.stringify(request));
    },
    preventScreenDimming: function()
    {
        var request = {name:"preventScreenDimming"};
        extension.postMessage(JSON.stringify(request));
    },
    releaseSounds: function()
    {
        var request = {name:"releaseSounds"};
        return extension.internal.sendSyncMessage(JSON.stringify(request));
    },
    updateLocale: function( value )
    {
        var request = {name:"updateLocale",data:value};
        extension.postMessage(JSON.stringify(request));
    },
    restoreIcycle1: function()
    {
        var request = {name:"restoreIcycle1"};
        extension.postMessage(JSON.stringify(request));
    },
    signIn: function()
    {
        var request = {name:"signIn"};
        extension.postMessage(JSON.stringify(request));
    },
    signOut: function()
    {
        var request = {name:"signOut"};
        extension.postMessage(JSON.stringify(request));
    },
    saveprogress: function()
    {
        var request = {name:"saveprogress"};
        extension.postMessage(JSON.stringify(request));
    },
    submitAchievement: function( value )
    {
        var request = {name:"submitAchievement",data:value};
        extension.postMessage(JSON.stringify(request));
    },
    submitScore: function( value )
    {
        var request = {name:"submitScore",data:value};
        extension.postMessage(JSON.stringify(request));
    },
    viewLeaderboard: function()
    {
        var request = {name:"viewLeaderboard"};
        extension.postMessage(JSON.stringify(request));
    },
    openAchievements: function()
    {
        var request = {name:"openAchievements"};
        extension.postMessage(JSON.stringify(request));
    },
    startIcycle1: function()
    {
        var request = {name:"startIcycle1"};
        extension.postMessage(JSON.stringify(request));
    },
    startIcycle2: function()
    {
        var request = {name:"startIcycle2"};
        extension.postMessage(JSON.stringify(request));
    },
    loadAdditionalFont: function(value)
    {
        var request = {name:"loadAdditionalFont",data:value};
        extension.postMessage(JSON.stringify(request));
    },
    loadAdditionalFontLanguageSwitch: function(value)
    {
        var request = {name:"loadAdditionalFontLanguageSwitch",data:value};
        extension.postMessage(JSON.stringify(request));
    },

    // stuff called from ContextGLES:

    sendGLESCommands: function( value )
    {
        //var request = {name:"sendGLESCommands",data:value};
        //console.log("postbinarymessage "+ extension);
        extension.postMessage(value);
    },


};


extension.setMessageListener(function(message)
{
    if(message instanceof ArrayBuffer){
        //console.log("binary message from Java received: " + message);
        window.mainApplication.onTouchEvent(message);
        return;
    }
    //console.log("message from Java received: " + message);

    var value = JSON.parse( message );
    switch( value.id) {
        case "openIAP":
            window.mainApplication.openIAP();
            break;
        case "purchaseResult":
            window.mainApplication.purchaseCallback( value.data );
            break;
        case "onBackPressed":
            window.mainApplication.onBackPressed();
            break;
        case "disableSound":
            window.mainApplication.disableSound();
            break;
        case "enableSound":
            window.mainApplication.enableSound();
            break;
        case "startTimer":
            window.mainApplication.startTimer();
            break;
        case "updatePrices":
            window.mainApplication.updatePrices(value.data.split(";"));
            break;
        case "onConnected":
            window.mainApplication.onConnected();
            break;
        case "onDisconnect":
            window.mainApplication.onDisconnect();
            break;

        case "updateSize":
            var size = value.data.split(";");
            window.mainApplication.updateSize(size[0],size[1]);
            break;
        case "touchEvents":
            //console.log("recieved touch event "+ value.data);
            window.mainApplication.onTouchEvent(value.data);
            //window.mainApplication.updateSize(size[0],size[1]);
            break;
        case "render":
            //console.log("render ");
            window.mainApplication.render();
            //window.mainApplication.updateSize(size[0],size[1]);
            break;
        case "additionalTextureIsFinishedLanguageSwitch":
            //console.log("render ");
            window.mainApplication.additionalTextureIsFinishedLanguageSwitch();
            //window.mainApplication.updateSize(size[0],size[1]);
            break;
        case "additionalTextureIsFinished":
            //console.log("render ");
            window.mainApplication.additionalTextureIsFinished();
            //window.mainApplication.updateSize(size[0],size[1]);
            break;
        case "setAgeNotPassed":
            //console.log("render ");
            window.mainApplication.setAgeNotPassed();
            //window.mainApplication.updateSize(size[0],size[1]);
            break;




    }

});

exports = LoaderHandler;